VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AlphaPic"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'========
'AlphaPic
'========
'
'Version 3.2.4
'
'A simplistic stand-in for the StdPicture object that uses AlphaBlend()
'for rendering.
'
'It can be loaded with a picture for various VB6 "Canvases" such as Forms,
'PictureBoxes, UserControls, and hopefully even Printer objects though
'the latter hasn't been tested yet.  This picture can then be rendered
'with transparency onto a Canvas.
'

'Win32 definitions ----------------------------------------------------

Private Const WIN32_NULL As Long = 0
Private Const WIN32_FALSE As Long = 0
Private Const WIN32_TRUE As Long = 1 'Tests should use <> WIN32_FALSE.

Private Const GMEM_MOVEABLE As Long = &H2&

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    ByRef Destination As Any, _
    ByRef Source As Any, _
    ByVal Length As Long)

Private Declare Function GlobalAlloc Lib "kernel32" ( _
    ByVal uFlags As Long, _
    ByVal dwBytes As Long) As Long
    
Private Declare Function GlobalFree Lib "kernel32" ( _
    ByVal hMem As Long) As Long
    
Private Declare Function GlobalLock Lib "kernel32" ( _
    ByVal hMem As Long) As Long
    
Private Declare Function GlobalUnlock Lib "kernel32" ( _
    ByVal hMem As Long) As Long

'OLE definitions ------------------------------------------------------

Public Enum COLOR_CONSTANTS
    CLR_NONE = &HFFFFFFFF
End Enum

Private Const S_OK As Long = 0

Private Type IID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Declare Function CLSIDFromString Lib "ole32" ( _
    ByVal lpsz As Long, _
    ByRef clsid As IID) As Long

Private Declare Function CreateStreamOnHGlobal Lib "ole32" ( _
    ByVal hGlobal As Long, _
    ByVal fDeleteOnRelease As Long, _
    ByRef Stream As Object) As Long

Private Type PICTDESC
    cbSizeOfStruct As Long
    picType As Long
    hBitmap As Long
    hPal As Long
End Type

Private Declare Function OleCreatePictureIndirect Lib "oleaut32" ( _
    ByRef PICTDESC As PICTDESC, _
    ByRef IID As IID, _
    ByVal fOwn As Long, _
    ByRef Obj As Object) As Long

Private Declare Function OleTranslateColor Lib "oleaut32" ( _
    ByVal clr As OLE_COLOR, _
    ByVal hPal As Long, _
    ByRef retColorRef As Long) As Long

'GDI definitions ------------------------------------------------------

Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

'GDI+ definitions -----------------------------------------------------

Private Const ONE_HUNDRED_PERCENT As Byte = &HFF

Private Enum GdiplusStatus
    Ok = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
End Enum

Private Type GdiplusStartupInput
    GdiplusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Declare Function GdiplusStartup Lib "gdiplus" ( _
    ByRef Token As Long, _
    ByRef InputBuf As GdiplusStartupInput, _
    ByVal pOutputBuf As Long) As GdiplusStatus

Private Declare Function GdiplusShutdown Lib "gdiplus" (ByVal Token As Long) As GdiplusStatus

Private Enum PixelFormat
    [_PixelFormatIndexed] = &H10000
    [_PixelFormatGDI] = &H20000
    [_PixelFormatAlpha] = &H40000
    [_PixelFormatCanonical] = &H200000
    [_PixelFormatPAlpha] = &H80000
    PixelFormat1bppIndexed = &H1& Or &H100& Or [_PixelFormatIndexed] Or [_PixelFormatGDI]
                           '(1 | ( 1 << 8) | PixelFormatIndexed | PixelFormatGDI)
    PixelFormat4bppIndexed = &H2& Or &H400& Or [_PixelFormatIndexed] Or [_PixelFormatGDI]
                           '(2 | ( 4 << 8) | PixelFormatIndexed | PixelFormatGDI)
    PixelFormat8bppIndexed = &H3& Or &H800& Or [_PixelFormatIndexed] Or [_PixelFormatGDI]
                           '(3 | ( 8 << 8) | PixelFormatIndexed | PixelFormatGDI)
    PixelFormat16bppRGB555 = &H5& Or &H1000& Or [_PixelFormatGDI]
                           '(5 | (16 << 8) | PixelFormatGDI)
    PixelFormat24bppRGB = &H8& Or &H1800& Or [_PixelFormatGDI]
                           '(8 | (24 << 8) | PixelFormatGDI)
    PixelFormat32bppRGB = &H9& Or &H2000& Or [_PixelFormatGDI]
                           '(9 | (32 << 8) | PixelFormatGDI)
    PixelFormat32bppARGB = &HA& Or &H2000& Or [_PixelFormatAlpha] Or [_PixelFormatGDI] Or [_PixelFormatCanonical]
                           '(10 | (32 << 8) | PixelFormatAlpha | PixelFormatGDI | PixelFormatCanonical)
    PixelFormat32bppPARGB = &HB& Or &H2000& Or [_PixelFormatAlpha] Or [_PixelFormatPAlpha] Or [_PixelFormatGDI]
                           '(11 | (32 << 8) | PixelFormatAlpha | PixelFormatPAlpha | PixelFormatGDI)
End Enum

Private Declare Function GdipCloneBitmapAreaI Lib "gdiplus" ( _
   ByVal X As Long, _
   ByVal Y As Long, _
   ByVal Width As Long, _
   ByVal Height As Long, _
   ByVal PixelFormat As PixelFormat, _
   ByVal SrcBitmap As Long, _
   ByRef DestBitmap As Long) As GdiplusStatus

Private Declare Function GdipCreateBitmapFromFile Lib "gdiplus" ( _
    ByVal pFileName As Long, _
    ByRef Bitmap As Long) As GdiplusStatus

Private Declare Function GdipCreateBitmapFromHBITMAP Lib "gdiplus" ( _
    ByVal hBitmap As Long, _
    ByVal hPal As Long, _
    ByRef Bitmap As Long) As Long

Private Declare Function GdipCreateBitmapFromGraphics Lib "gdiplus" ( _
    ByVal Width As Long, _
    ByVal Height As Long, _
    ByVal Graphics As Long, _
    ByRef Bitmap As Long) As GdiplusStatus

Private Declare Function GdipCreateBitmapFromStream Lib "gdiplus" ( _
    ByVal Stream As IUnknown, _
    ByRef Bitmap As Long) As GdiplusStatus

Private Declare Function GdipCreateFromHDC Lib "gdiplus" ( _
    ByVal hDC As Long, _
    ByRef Graphics As Long) As GdiplusStatus

Private Declare Function GdipCreateHBITMAPFromBitmap Lib "gdiplus" ( _
    ByVal hGdipBitmap As Long, _
    ByRef hBitmapReturn As Long, _
    Optional ByVal BackgroundARGB As Long = 0) As GdiplusStatus

Private Declare Function GdipCreateImageAttributes Lib "gdiplus" ( _
    ByRef ImageAttributes As Long) As GdiplusStatus

Private Declare Function GdipDeleteGraphics Lib "gdiplus" ( _
    ByVal Graphics As Long) As GdiplusStatus

Private Declare Function GdipDisposeImage Lib "gdiplus" (ByVal Image As Long) As GdiplusStatus

Private Declare Function GdipDisposeImageAttributes Lib "gdiplus" ( _
    ByVal ImageAttributes As Long) As GdiplusStatus

Private Declare Function GdipDrawImageRectI Lib "gdiplus" ( _
    ByVal Graphics As Long, _
    ByVal Image As Long, _
    ByVal Left As Long, _
    ByVal Top As Long, _
    ByVal Width As Long, _
    ByVal Height As Long) As GdiplusStatus

Private Enum Unit
    UnitWorld = 0
    UnitDisplay = 1
    UnitPixel = 2
    UnitPoint = 3
    UnitInch = 4
    UnitDocument = 5
    UnitMillimeter = 6
End Enum

Private Declare Function GdipDrawImageRectRectI Lib "gdiplus" ( _
    ByVal Graphics As Long, _
    ByVal Image As Long, _
    ByVal dstx As Long, _
    ByVal dsty As Long, _
    ByVal dstwidth As Long, _
    ByVal dstheight As Long, _
    ByVal srcx As Long, _
    ByVal srcy As Long, _
    ByVal srcwidth As Long, _
    ByVal srcheight As Long, _
    ByVal srcUnit As Unit, _
    ByVal ImageAttributes As Long, _
    Optional ByVal pCallback As Long = WIN32_NULL, _
    Optional ByVal pCallbackData As Long = WIN32_NULL) As GdiplusStatus

Private Declare Function GdipGetImageGraphicsContext Lib "gdiplus" ( _
    ByVal Image As Long, _
    ByRef Graphics As Long) As GdiplusStatus

Private Declare Function GdipGetImageDimension Lib "gdiplus" ( _
    ByVal Image As Long, _
    ByRef Width As Single, _
    ByRef Height As Single) As GdiplusStatus

Public Enum RotateFlipType
    RotateNoneFlipNone = 0
    Rotate90FlipNone = 1
    Rotate180FlipNone = 2
    Rotate270FlipNone = 3
    RotateNoneFlipX = 4
    Rotate90FlipX = 5
    Rotate180FlipX = 6
    Rotate270FlipX = 7
    RotateNoneFlipY = Rotate180FlipX
    Rotate90FlipY = Rotate270FlipX
    Rotate180FlipY = RotateNoneFlipX
    Rotate270FlipY = Rotate90FlipX
    RotateNoneFlipXY = Rotate180FlipNone
    Rotate90FlipXY = Rotate270FlipNone
    Rotate180FlipXY = RotateNoneFlipNone
    Rotate270FlipXY = Rotate90FlipNone
End Enum
#If False Then
Dim RotateNoneFlipNone, Rotate90FlipNone, Rotate180FlipNone, Rotate270FlipNone
Dim RotateNoneFlipX, Rotate90FlipX, Rotate180FlipX, Rotate270FlipX
Dim RotateNoneFlipY, Rotate90FlipY, Rotate180FlipY, Rotate270FlipY
Dim RotateNoneFlipXY, Rotate90FlipXY, Rotate180FlipXY, Rotate270FlipXY
#End If

Private Declare Function GdipImageRotateFlip Lib "gdiplus" ( _
    ByVal gdipImage As Long, _
    ByVal rfType As RotateFlipType) As GdiplusStatus

Private Declare Function GdipResetWorldTransform Lib "gdiplus" ( _
    ByVal Graphics As Long) As GdiplusStatus

Public Enum GpMatrixOrder
    MatrixOrderPrepend
    MatrixOrderAppend
End Enum
#If False Then
Dim MatrixOrderPrepend, MatrixOrderAppend
#End If

Private Declare Function GdipRotateWorldTransform Lib "gdiplus" ( _
    ByVal Graphics As Long, _
    ByVal angle As Single, _
    ByVal order As GpMatrixOrder) As GdiplusStatus

Private Enum ColorAdjustType
    ColorAdjustTypeDefault
    ColorAdjustTypeBitmap
    ColorAdjustTypeBrush
    ColorAdjustTypePen
    ColorAdjustTypeText
    [_ColorAdjustTypeCount]
    [_ColorAdjustTypeAny]
End Enum

Private Declare Function GdipSetImageAttributesColorKeys Lib "gdiplus" ( _
    ByVal ImageAttributes As Long, _
    ByVal ColorAdjustType As ColorAdjustType, _
    ByVal enableFlag As Long, _
    Optional ByVal colorLow As Long = vbBlack, _
    Optional ByVal colorHigh As Long = vbBlack) As GdiplusStatus

Private Type ColorMatrix
    m(4, 4) As Single 'Row & Col are inverted from the C/C++ convention.
End Type

Private Enum ColorMatrixFlags
    ColorMatrixFlagsDefault = 0
    ColorMatrixFlagsSkipGrays = 1
    ColorMatrixFlagsAltGray = 2
End Enum

Private Declare Function GdipSetImageAttributesColorMatrix Lib "gdiplus" ( _
    ByVal ImageAttributes As Long, _
    ByVal ColorAdjustType As ColorAdjustType, _
    ByVal enableFlag As Long, _
    Optional ByVal pColorMatrix As Long = WIN32_NULL, _
    Optional ByVal pGrayMatrix As Long = WIN32_NULL, _
    Optional ByVal ColorMatrixFlags As ColorMatrixFlags = ColorMatrixFlagsDefault) _
        As GdiplusStatus

Private Declare Function GdipSetImageAttributesRemapTable Lib "gdiplus" ( _
    ByVal ImageAttributes As Long, _
    ByVal caType As ColorAdjustType, _
    ByVal enableFlag As Long, _
    ByVal mapSize As Long, _
    ByVal pMap As Long) As GdiplusStatus

Private Enum QualityMode
    QualityModeInvalid = -1
    QualityModeDefault = 0
    QualityModeLow = 1
    QualityModeHigh = 2
End Enum

Public Enum InterpolationMode
    [_imInvalid] = QualityModeInvalid
    imDefault = QualityModeDefault
    imLowQuality = QualityModeLow
    imHighQuality = QualityModeHigh
    imBilinear = QualityModeHigh + 1
    imBicubic = QualityModeHigh + 2
    imNearestNeighbor = QualityModeHigh + 3
    imHighQualityBilinear = QualityModeHigh + 4
    imHighQualityBicubic = QualityModeHigh + 5
End Enum
#If False Then
Dim imDefault, imLowQuality, imHighQuality, imBilinear, imBicubic, imNearestNeighbor
Dim imHighQualityBilinear, imHighQualityBicubic
#End If

Private Declare Function GdipSetInterpolationMode Lib "gdiplus" ( _
    ByVal Graphics As Long, _
    ByVal InterpolationMode As InterpolationMode) As GdiplusStatus

Private Declare Function GdipTranslateWorldTransform Lib "gdiplus" ( _
    ByVal Graphics As Long, _
    ByVal dX As Single, _
    ByVal dY As Single, _
    ByVal order As GpMatrixOrder) As GdiplusStatus

Private GdipToken As Long
Private GdipInitialized As Boolean
Private IID_IPicture As IID
Private ImageAttributes As Long

Private mAlpha As Byte
Private mWidth As Long
Private mHeight As Long
Private mQuality As InterpolationMode
Private mTranspColor As Long

Private mGdipBitmap As Long

Public Property Get Alpha() As Byte
    Alpha = mAlpha
End Property

Public Property Let Alpha(ByVal RHS As Byte)
    'Alpha applied globally (all pixels) to Render operations.
    Dim ColorMatrix As ColorMatrix

    mAlpha = RHS
    If mAlpha = ONE_HUNDRED_PERCENT Then
        If TranspColor = CLR_NONE Then
            ReleaseImageAttributes
        Else
            'ClearColorMatrix:
            GdipSetImageAttributesColorMatrix ImageAttributes, _
                                              ColorAdjustTypeBitmap, _
                                              WIN32_FALSE
        End If
    Else
        If ImageAttributes = WIN32_NULL Then
            If GdipCreateImageAttributes(ImageAttributes) <> Ok Then Exit Property
        End If
        InitNewColorMatrix ColorMatrix
        ColorMatrix.m(3, 3) = CSng(mAlpha) / ONE_HUNDRED_PERCENT
        GdipSetImageAttributesColorMatrix ImageAttributes, _
                                          ColorAdjustTypeBitmap, _
                                          WIN32_TRUE, _
                                          VarPtr(ColorMatrix)
    End If
End Property

Friend Property Get GdipBitmap() As Long
    GdipBitmap = mGdipBitmap
End Property

Public Property Get IsLoaded() As Boolean
    IsLoaded = mGdipBitmap <> WIN32_NULL
End Property

Public Property Get Height() As Long
    Height = mHeight
End Property

Private Property Let Height(ByVal RHS As Long)
    mHeight = RHS
End Property

Public Property Get Picture(Optional ByVal BackColor As OLE_COLOR) As stdole.StdPicture
    Dim hBitmap As Long
    Dim PICTDESC As PICTDESC
    Dim HRESULT As Long
    
    If Not GdipInitialized Then Exit Property
    
    If IsLoaded Then
        If GdipCreateHBITMAPFromBitmap(GdipBitmap, _
                                       hBitmap, _
                                       OleColorToARGB(BackColor, 0)) = Ok Then
            With PICTDESC
               .cbSizeOfStruct = LenB(PICTDESC)
               .picType = vbPicTypeBitmap
               .hBitmap = hBitmap
               '.hPal = 0
            End With
            HRESULT = OleCreatePictureIndirect(PICTDESC, _
                                               IID_IPicture, _
                                               WIN32_TRUE, _
                                               Picture)
            If HRESULT <> S_OK Then DeleteObject hBitmap
        End If
    End If
End Property

Public Property Get Quality() As InterpolationMode
    Quality = mQuality
End Property

Public Property Let Quality(ByVal RHS As InterpolationMode)
    mQuality = RHS
End Property

Public Property Get TranspColor() As Long
    TranspColor = mTranspColor
End Property

Public Property Let TranspColor(ByVal RHS As Long)
    'Transparent color applied to Render operations.

    Dim TranspColorARGB As Long

    mTranspColor = RHS
    If RHS = CLR_NONE Then
        If Alpha = ONE_HUNDRED_PERCENT Then
            ReleaseImageAttributes
        Else
            'ClearColorKeys:
            GdipSetImageAttributesColorKeys ImageAttributes, _
                                            ColorAdjustTypeBitmap, _
                                            WIN32_FALSE
        End If
    Else
        If ImageAttributes = WIN32_NULL Then
            If GdipCreateImageAttributes(ImageAttributes) <> Ok Then Exit Property
        End If
        TranspColorARGB = OleColorToARGB(mTranspColor, &HFF)
        GdipSetImageAttributesColorKeys ImageAttributes, _
                                        ColorAdjustTypeBitmap, _
                                        WIN32_TRUE, _
                                        TranspColorARGB, _
                                        TranspColorARGB
    End If
End Property

Public Property Get Width() As Long
    Width = mWidth
End Property

Private Property Let Width(ByVal RHS As Long)
    mWidth = RHS
End Property

Public Sub ClearColorMap()
    'On errors, return silently.
    
    If ImageAttributes <> WIN32_NULL Then
        GdipSetImageAttributesRemapTable ImageAttributes, _
                                         ColorAdjustTypeDefault, _
                                         WIN32_FALSE, _
                                         0, _
                                         WIN32_NULL
    End If
End Sub

Public Function CloneBitmap( _
    ByVal SrcAlphaPic As AlphaPic, _
    Optional ByVal X As Long = 0, _
    Optional ByVal Y As Long = 0, _
    Optional ByVal cX As Long = -1, _
    Optional ByVal cY As Long = -1) As Boolean
    'Returns True upon success.  On failure this instance will have no GdipBitmap.
    Dim GdipWidth As Single
    Dim GdipHeight As Single

    If Not GdipInitialized Then Exit Function

    ReleaseBitmap
    With SrcAlphaPic
        If .IsLoaded Then
            If cX < 0 Then cX = .Width
            If cY < 0 Then cY = .Height
            Alpha = .Alpha
            Quality = .Quality
            TranspColor = .TranspColor
            If GdipCloneBitmapAreaI(X, _
                                    Y, _
                                    cX, _
                                    cY, _
                                    PixelFormat32bppARGB, _
                                    .GdipBitmap, _
                                    mGdipBitmap) = Ok Then
                If GdipGetImageDimension(mGdipBitmap, GdipWidth, GdipHeight) = Ok Then
                    Width = GdipWidth
                    Height = GdipHeight
                    CloneBitmap = True
                End If
            End If
        End If
    End With
End Function

Public Function LoadBitmap(ByRef Source As Variant) As Boolean
    'After loading, applies ImageAttributes if valid (Alpha and/or TranspColor if
    'previously assigned non-default values).
    '
    'Returns True upon success.
    Dim Bytes() As Byte
    Dim GdipGraphics As Long
    Dim NewGdipBitmap As Long
    
    If Not GdipInitialized Then Exit Function
    
    ReleaseBitmap
    If VarType(Source) = (vbByte Or vbArray) Then
        Bytes = Source
        LoadBitmap = LoadPictureBytes(Bytes)
    ElseIf VarType(Source) = vbString Then
        LoadBitmap = LoadPictureFile(Source)
    ElseIf TypeOf Source Is stdole.StdPicture Then
        LoadBitmap = LoadPicturePicture(Source)
    End If
    If LoadBitmap And ImageAttributes <> WIN32_NULL Then
        If GdipGetImageGraphicsContext(mGdipBitmap, GdipGraphics) = Ok Then
            If GdipCreateBitmapFromGraphics(Width, Height, GdipGraphics, NewGdipBitmap) = Ok Then
                GdipDeleteGraphics GdipGraphics
                If GdipGetImageGraphicsContext(NewGdipBitmap, GdipGraphics) = Ok Then
                    If GdipSetInterpolationMode(GdipGraphics, Quality) <> Ok Then
                        GdipDisposeImage NewGdipBitmap
                        Exit Function
                    End If
                    If GdipDrawImageRectRectI(GdipGraphics, _
                                              mGdipBitmap, _
                                              0, _
                                              0, _
                                              Width, _
                                              Height, _
                                              0, _
                                              0, _
                                              Width, _
                                              Height, _
                                              UnitPixel, _
                                              ImageAttributes) = Ok Then
                        GdipDisposeImage mGdipBitmap
                        mGdipBitmap = NewGdipBitmap
                    Else
                        GdipDisposeImage NewGdipBitmap
                    End If
                    GdipDeleteGraphics GdipGraphics
                Else
                    GdipDisposeImage NewGdipBitmap
                End If
            Else
                GdipDeleteGraphics GdipGraphics
            End If
        End If
        GdipDeleteGraphics GdipGraphics
    End If
End Function

Public Sub ReleaseBitmap()
    If IsLoaded Then
        GdipDisposeImage mGdipBitmap
        mGdipBitmap = WIN32_NULL
        Width = 0
        Height = 0
    End If
End Sub

Public Function Render( _
    ByVal Canvas As Object, _
    Optional ByVal X As Long = 0, _
    Optional ByVal Y As Long = 0, _
    Optional ByVal cX As Long = -1, _
    Optional ByVal cY As Long = -1) As Boolean
    'Draws mGdipBitmap to a rectangle on Canvas with scaling and alpha transparency.
    '
    'When cX or cY are < 0 the source image dimensions are used.
    '
    'Returns True upon success.

    Dim GdipGraphics As Long
    
    If IsLoaded Then
        If cX < 0 Then cX = Width
        If cY < 0 Then cY = Height
        If GdipCreateFromHDC(Canvas.hDC, GdipGraphics) <> Ok Then Exit Function
        If GdipSetInterpolationMode(GdipGraphics, Quality) <> Ok Then
            GdipDeleteGraphics GdipGraphics
            Exit Function
        End If
        If ImageAttributes = WIN32_NULL Then
            Render = GdipDrawImageRectI(GdipGraphics, mGdipBitmap, X, Y, cX, cY) = Ok
        Else
            Render = GdipDrawImageRectRectI(GdipGraphics, _
                                            mGdipBitmap, _
                                            X, _
                                            Y, _
                                            cX, _
                                            cY, _
                                            0, _
                                            0, _
                                            Width, _
                                            Height, _
                                            UnitPixel, _
                                            ImageAttributes) = Ok
        End If
        GdipDeleteGraphics GdipGraphics
        Canvas.Point 0, 0 'Triggers AutoRedraw if True.
    End If
End Function

Public Function RenderRotated( _
    ByVal Canvas As Object, _
    ByVal angle As Single, _
    Optional ByVal X As Long = 0, _
    Optional ByVal Y As Long = 0, _
    Optional ByVal cX As Long = -1, _
    Optional ByVal cY As Long = -1) As Boolean
    'Draws mGdipBitmap to a rectangle on Canvas with rotation, scaling, and alpha
    'transparency.
    '
    'The angle is in degrees.
    '
    'When cX or cY are < 0 the source image dimensions are used.
    '
    'Returns True upon success.

    Dim GdipGraphics As Long
    Dim dX As Single
    Dim dY As Single
    
    If IsLoaded Then
        If cX < 0 Then cX = Width
        If cY < 0 Then cY = Height
        If GdipCreateFromHDC(Canvas.hDC, GdipGraphics) <> Ok Then Exit Function
        If GdipSetInterpolationMode(GdipGraphics, Quality) <> Ok Then
            GdipDeleteGraphics GdipGraphics
            Exit Function
        End If
        dX = X + cX / 2!
        dY = Y + cY / 2!
        If GdipTranslateWorldTransform(GdipGraphics, dX, dY, MatrixOrderPrepend) = Ok Then
            If GdipRotateWorldTransform(GdipGraphics, angle, MatrixOrderPrepend) = Ok Then
                If GdipTranslateWorldTransform(GdipGraphics, -dX, -dY, MatrixOrderPrepend) = Ok Then
                    If ImageAttributes = WIN32_NULL Then
                        RenderRotated = GdipDrawImageRectI(GdipGraphics, _
                                                           mGdipBitmap, _
                                                           X, _
                                                           Y, _
                                                           cX, _
                                                           cY) = Ok
                    Else
                        RenderRotated = GdipDrawImageRectRectI(GdipGraphics, _
                                                               mGdipBitmap, _
                                                               X, _
                                                               Y, _
                                                               cX, _
                                                               cY, _
                                                               0, _
                                                               0, _
                                                               Width, _
                                                               Height, _
                                                               UnitPixel, _
                                                               ImageAttributes) = Ok
                    End If
                End If
            End If
        End If
        GdipResetWorldTransform GdipGraphics
        GdipDeleteGraphics GdipGraphics
        Canvas.Point 0, 0 'Triggers AutoRedraw if True.
    End If
End Function

Public Sub RotateFlip(ByVal RotateFlipType As RotateFlipType)
    If IsLoaded Then
        GdipImageRotateFlip mGdipBitmap, RotateFlipType
    End If
End Sub

Public Function StretchBitmap(ByVal NewWidth As Long, ByVal NewHeight As Long) As Boolean
    'Returns True upon success.
    Dim GdipGraphics As Long
    Dim NewGdipBitmap As Long
    
    If GdipGetImageGraphicsContext(mGdipBitmap, GdipGraphics) = Ok Then
        If GdipCreateBitmapFromGraphics(NewWidth, NewHeight, GdipGraphics, NewGdipBitmap) = Ok Then
            GdipDeleteGraphics GdipGraphics
            If GdipGetImageGraphicsContext(NewGdipBitmap, GdipGraphics) = Ok Then
                If GdipSetInterpolationMode(GdipGraphics, Quality) <> Ok Then
                    GdipDeleteGraphics GdipGraphics
                    GdipDisposeImage NewGdipBitmap
                    Exit Function
                End If
                If GdipDrawImageRectI(GdipGraphics, mGdipBitmap, 0, 0, NewWidth, NewHeight) = Ok Then
                    GdipDisposeImage mGdipBitmap
                    mGdipBitmap = NewGdipBitmap
                    Width = NewWidth
                    Height = NewHeight
                    StretchBitmap = True
                Else
                    GdipDisposeImage NewGdipBitmap
                End If
                GdipDeleteGraphics GdipGraphics
            Else
                GdipDisposeImage NewGdipBitmap
            End If
        Else
            GdipDeleteGraphics GdipGraphics
        End If
    End If
End Function

Public Sub SetColorMap(ByRef ColorMap() As Long)
    'ColorMap() is a 1-D base-0 array of one to many ARGB color pairs:
    '
    '   Old Color, New Color, Old Color, New Color, ...
    '
    'Should an array of: Type ColorMap
    '                        oldColor As Long
    '                        newColor As Long
    '                    End Type
    '... but it isn't worth a static module just for one declaration.
    '
    'On errors, return silently.

    If UBound(ColorMap) + 1 And &H1& Then Exit Sub 'Odd number of elements.
    If ImageAttributes = WIN32_NULL Then
        If GdipCreateImageAttributes(ImageAttributes) <> Ok Then Exit Sub
    End If
    GdipSetImageAttributesRemapTable ImageAttributes, _
                                     ColorAdjustTypeDefault, _
                                     WIN32_TRUE, _
                                     UBound(ColorMap) + 1, _
                                     VarPtr(ColorMap(0))
End Sub

Private Sub InitNewColorMatrix(ByRef ColorMatrix As ColorMatrix)
    Dim I As Long

    For I = 0 To 4
        ColorMatrix.m(I, I) = 1
    Next
End Sub

Private Function LoadPictureBytes(ByRef SourceBytes() As Byte) As Boolean
    'Returns True upon success.
    Dim Size As Long
    Dim hMem  As Long
    Dim lpMem  As Long
    Dim Stream As IUnknown
    Dim GdipWidth As Single
    Dim GdipHeight As Single
    
    If Not GdipInitialized Then Exit Function

    Size = UBound(SourceBytes) - LBound(SourceBytes) + 1
    If Size < 1 Then Exit Function
    
    hMem = GlobalAlloc(GMEM_MOVEABLE, Size)
    If hMem = WIN32_NULL Then Exit Function
    
    lpMem = GlobalLock(hMem)
    If lpMem = WIN32_NULL Then GoTo KernelCleanup
    
    CopyMemory ByVal lpMem, SourceBytes(LBound(SourceBytes)), Size
    GlobalUnlock hMem
    If CreateStreamOnHGlobal(hMem, WIN32_TRUE, Stream) <> S_OK Then GoTo KernelCleanup
    
    If GdipCreateBitmapFromStream(Stream, mGdipBitmap) <> Ok Then GoTo KernelCleanup
    
    If GdipGetImageDimension(mGdipBitmap, GdipWidth, GdipHeight) = Ok Then
        Width = GdipWidth
        Height = GdipHeight
        LoadPictureBytes = True
    Else
        ReleaseBitmap
    End If

KernelCleanup:
    GlobalFree hMem
End Function

Private Function LoadPictureFile(ByVal SourceFile As String) As Boolean
    'Returns True upon success.
    Dim GdipWidth As Single
    Dim GdipHeight As Single
    
    If Not GdipInitialized Then Exit Function
    
    If GdipCreateBitmapFromFile(StrPtr(SourceFile), mGdipBitmap) <> Ok Then Exit Function
    
    If GdipGetImageDimension(mGdipBitmap, GdipWidth, GdipHeight) = Ok Then
        Width = GdipWidth
        Height = GdipHeight
        LoadPictureFile = True
    Else
        ReleaseBitmap
    End If
End Function

Private Function LoadPicturePicture(ByVal SourcePicture As stdole.StdPicture) As Boolean
    'Returns True upon success.
    Dim GdipWidth As Single
    Dim GdipHeight As Single
    
    If Not GdipInitialized Then Exit Function
    
    If GdipCreateBitmapFromHBITMAP(SourcePicture.Handle, _
                                   SourcePicture.hPal, _
                                   mGdipBitmap) <> Ok Then Exit Function
    
    If GdipGetImageDimension(mGdipBitmap, GdipWidth, GdipHeight) = Ok Then
        Width = GdipWidth
        Height = GdipHeight
        LoadPicturePicture = True
    Else
        ReleaseBitmap
    End If
End Function

Private Function OleColorToARGB(ByVal Color As OLE_COLOR, ByVal Alpha As Byte) As Long
    'Convert OLE_COLOR to fully transparent ARGB format.
    Dim AlphaLong As Long

    OleTranslateColor Color, WIN32_NULL, OleColorToARGB
    If Alpha = &HFF Then
        AlphaLong = &HFF000000
    ElseIf Alpha <> 0 Then
        AlphaLong = (Alpha And &H7F) * &H1000000
        If Alpha >= 128 Then AlphaLong = AlphaLong Or &H80000000
    End If
    
    OleColorToARGB = (OleColorToARGB And &HFF&) * &H10000 _
                  Or (OleColorToARGB And &HFF00&) _
                  Or (OleColorToARGB And &HFF0000) \ &H10000 _
                  Or AlphaLong
End Function

Private Sub ReleaseImageAttributes()
    If ImageAttributes <> WIN32_NULL Then
        GdipDisposeImageAttributes ImageAttributes
        ImageAttributes = WIN32_NULL
        mAlpha = &HFF
    End If
End Sub

Private Sub Class_Initialize()
    Dim GdipSI As GdiplusStartupInput

    CLSIDFromString StrPtr("{7BF80980-BF32-101A-8BBB-00AA00300CAB}"), IID_IPicture
    GdipSI.GdiplusVersion = 1
    GdipInitialized = GdiplusStartup(GdipToken, GdipSI, WIN32_NULL) = Ok
    mAlpha = ONE_HUNDRED_PERCENT
    mTranspColor = CLR_NONE
End Sub

Private Sub Class_Terminate()
    ReleaseImageAttributes
    ReleaseBitmap
    If GdipInitialized Then GdiplusShutdown GdipToken
End Sub

